#include <gb/drawing.h>
#include <gb/gb.h>
#include <rand.h>
#include <stdio.h>
#include "funktionen.c"
#include "dsomenu.c"



// Datenspeicher d. 2 Kanle
// Array haben nur max. 127 Elemente
int pointsa1[70]; 
int pointsa2[70];
int pointsb1[70];
int pointsb2[70];

int pointsa1_old[70]; // alte Werte zwischenspeicher
int pointsa2_old[70];
int pointsb1_old[70];
int pointsb2_old[70];


// Speicher Menue
int menuitem;
int menustate;
int nextmenustate;

// Einstellungen:
unsigned timediv = 10; // ms/DIV, Wertebereich 1ms bis 100ms -> wird mit 10 multip.


// 10 mV/Div ^= 0, 50 mV/Div ^= 1, 200 mV/Div ^= 2, 500 mV/Div ^= 3, 
// 1 V/Div ^= 4, 2 V/Div ^= 5, 4 V/Div ^= 6, 8 V/Div ^= 7, 16 V/Div ^= 8 und 25 V/Div ^= 9 
unsigned cha_amp = 6;  
unsigned chb_amp = 6;


// 10 [0-9] Werte a 4 Zeichen
char ch_amp_werte[40] = "10mV50mV200m500m1 V 2 V 4 V 8 V 16 V 25V ";

		

char cha_mode[3] = "DC "; // Mode, Mglichkeiten: AC(A)-DC(D)-GND(G)
char chb_mode[3] = "DC ";



void dsotime(int programm) {
	

	koordinaten();
	dsomenu(&timediv, &cha_amp, &chb_amp, cha_mode, chb_mode);
	init_data(pointsa1, pointsa2, pointsb1, pointsb2, pointsa1_old, pointsa2_old, 
			  pointsb1_old, pointsb2_old, programm);

	menuitem = 1; // 1. Item
	menustate = 1; // 1. Item


	while(1){

		// alte punkte lschen
		// del_points(pointsa, pointsb); 
		//Punkte werden jetzt direkt in print_data gelscht

		// men machen 
		dsomenu(&timediv, &cha_amp, &chb_amp, cha_mode, chb_mode, &menuitem, &menustate, &nextmenustate, ch_amp_werte);

		// Daten zwischenspeichern
		copy_data(pointsa1, pointsa2, pointsb1, pointsb2, pointsa1_old, pointsa2_old, 
				  pointsb1_old, pointsb2_old);
		
		// Daten von der Schnittstelle lesen
		read_data(pointsa1, pointsa2, pointsb1, pointsb2, programm, &timediv);

		//  Daten aufbereiten
		transform_data(pointsa1, pointsa2, pointsb1, pointsb2, &cha_amp, &chb_amp, cha_mode, chb_mode);

		// Daten ausgeben
		print_data(pointsa1, pointsa2, pointsb1, pointsb2, pointsa1_old, pointsa2_old, 
				   pointsb1_old, pointsb2_old);
		
	}
}
